package fr.sanchezm.attestationsCovid19.utilities

import android.content.res.AssetManager
import com.tom_roush.pdfbox.pdmodel.PDDocument
import com.tom_roush.pdfbox.pdmodel.interactive.form.*
import fr.sanchezm.attestationsCovid19.data.db.entity.Attestation
import java.io.File
import java.io.IOException

class PdfUtils private constructor(private val assetManager: AssetManager, private val path: File?) {

    private val folderPath = "/attestations/"

    fun fillForm (attestation: Attestation) {
        try {
            // Load the document and get the AcroForm
            val document: PDDocument = PDDocument.load(assetManager.open("attestation.pdf"))
            val docCatalog = document.documentCatalog
            val acroForm = docCatalog.acroForm

            // Fill the text field
            val field = acroForm.getField("TextField") as PDTextField
            field.value = "Filled Text Field"
            // Optional: don't allow this field to be edited
            field.isReadOnly = true
            val checkbox = acroForm.getField("Checkbox")
            (checkbox as PDCheckbox).check()
//            val radio = acroForm.getField("Radio")
//            (radio as PDRadioButton).value = "Second"
//            val listbox = acroForm.getField("ListBox")
//            val listValues: MutableList<Int> = ArrayList()
//            listValues.add(1)
//            listValues.add(2)
//            (listbox as PDListBox).selectedOptionsIndex = listValues
//            val dropdown = acroForm.getField("Dropdown")
//            (dropdown as PDComboBox).setValue("Hello")
            val path = ""
//            val path: String = root.getAbsolutePath().toString() + "/Download/FilledForm.pdf"
//            tv.setText("Saved filled form to $path")
            document.save(path)
            document.close()
        } catch (e: IOException) {
            e.printStackTrace()
        }
    }

    companion object {
        @Volatile
        private var instance: PdfUtils? = null
        private val LOCK = Any()

        fun getInstance() = instance

        fun getInstance(assetManager: AssetManager, path: File?) = instance ?: synchronized(LOCK) {
            instance ?: PdfUtils(assetManager, path).also { instance = it }
        }
    }

}